diff --git a/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java b/src/main/java/net/minecraft/client/gui/HudDesignerScreen.java
similarity index 89%
rename from src/main/java/net/minecraft/client/gui/GuiHudDesigner.java
rename to src/main/java/net/minecraft/client/gui/HudDesignerScreen.java
index 9c6dec263..905ffb6df 100644
--- a/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java
+++ b/src/main/java/net/minecraft/client/gui/HudDesignerScreen.java
@@ -1,6 +1,12 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.hud.*;
+import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.hud.component.HudComponent;
+import net.minecraft.client.gui.hud.component.HudComponents;
+import net.minecraft.client.gui.hud.component.MovableHudComponent;
+import net.minecraft.client.gui.hud.component.layout.AbsoluteLayout;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.hud.component.layout.SnapLayout;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
@@ -11,8 +17,8 @@ import java.util.List;
 
 import static org.lwjgl.opengl.GL11.*;
 
-public class GuiHudDesigner
-    extends GuiScreen {
+public class HudDesignerScreen
+    extends Screen {
     private static final int BOTTOM_SPACE = 28;
     private final List<HudComponent> componentsUnderMouse = new ArrayList<>();
     private HudComponent heldComponent = null;
@@ -20,9 +26,9 @@ public class GuiHudDesigner
     private HudComponent snappedComponent = null;
     private ComponentAnchor snappedAnchor = null;
     private float screenPadding = 0.0f;
-    private GuiButton resetButton;
+    private ButtonElement resetButton;
 
-    public GuiHudDesigner(GuiScreen parent) {
+    public HudDesignerScreen(Screen parent) {
         super(parent);
     }
 
@@ -32,22 +38,22 @@ public class GuiHudDesigner
         this.screenPadding = mc.gameSettings.screenPadding.value;
         mc.gameSettings.screenPadding.set(0.0f);
 
-        add(new GuiButton(0, width / 2 - 100, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 178, 20, I18n.getInstance().translateKey("gui.hud_designer.button.done")));
-        add(resetButton = new GuiButton(1, width / 2 + 80, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20, 20, "")
+        add(new ButtonElement(0, width / 2 - 100, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 178, 20, I18n.getInstance().translateKey("gui.hud_designer.button.done")));
+        add(resetButton = new ButtonElement(1, width / 2 + 80, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_reset", "minecraft:gui/misc/button_reset_highlighted", "minecraft:gui/misc/button_reset"));
     }
 
     @Override
-    public void onClosed() {
-        super.onClosed();
+    public void removed() {
+        super.removed();
         mc.gameSettings.screenPadding.set(screenPadding);
     }
 
     @Override
-    protected void buttonPressed(GuiButton button) {
-        super.buttonPressed(button);
+    protected void buttonClicked(ButtonElement button) {
+        super.buttonClicked(button);
         if (button.id == 0) {
-            mc.displayGuiScreen(getParentScreen());
+            mc.displayScreen(getParentScreen());
         }
         if (button.id == 1) {
             HudComponents.INSTANCE.fromSettingsString(HudComponents.DEFAULT_LAYOUT);
@@ -55,10 +61,10 @@ public class GuiHudDesigner
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-        updateComponentsUnderMouse(mouseX, mouseY);
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        updateComponentsUnderMouse(mx, my);
         boolean clickedComponent = false;
-        if (mouseButton == 0) {
+        if (buttonNum == 0) {
             if (!componentsUnderMouse.isEmpty()) {
                 HudComponent componentUnderMouse = componentsUnderMouse.get(componentsUnderMouse.size() - 1);
                 if (componentUnderMouse instanceof MovableHudComponent) {
@@ -66,7 +72,7 @@ public class GuiHudDesigner
                     ComponentAnchor anchor = getClosestAnchor(
                         currentLayout.getComponentX(mc, componentUnderMouse, width),
                         currentLayout.getComponentY(mc, componentUnderMouse, height - BOTTOM_SPACE),
-                        componentUnderMouse, mouseX, mouseY);
+                        componentUnderMouse, mx, my);
                     Layout layout = new AbsoluteLayout(0, 0, anchor);
                     ((MovableHudComponent) componentUnderMouse).setLayout(layout);
 
@@ -79,7 +85,7 @@ public class GuiHudDesigner
 
         if (!clickedComponent) {
             heldComponent = null;
-            super.mouseClicked(mouseX, mouseY, mouseButton);
+            super.mouseClicked(mx, my, buttonNum);
         }
     }
 
@@ -217,27 +223,27 @@ public class GuiHudDesigner
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
-        if (mouseButton == 0) {
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        if (buttonNum == 0) {
             heldComponent = null;
             heldAnchor = null;
             snappedComponent = null;
             snappedAnchor = null;
         }
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+        super.mouseReleased(mx, my, buttonNum);
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
-        updateComponentsUnderMouse(mouseX, mouseY);
+    public void render(int xm, int ym, float partialTick) {
+        updateComponentsUnderMouse(xm, ym);
 
         if (heldComponent != null) {
-            updateHeldComponent(mouseX, mouseY);
+            updateHeldComponent(xm, ym);
         }
 
-        drawBackground();
+        renderTexturedBackground();
 
-        drawHudComponents(mouseX, mouseY);
+        drawHudComponents(xm, ym);
 
         Tessellator tessellator = Tessellator.instance;
         GL11.glDisable(GL_DEPTH_TEST);
@@ -259,16 +265,16 @@ public class GuiHudDesigner
             }
         }
 
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 
     @Override
-    public void drawBackground() {
-        super.drawBackground();
+    public void renderTexturedBackground() {
+        super.renderTexturedBackground();
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_FOG);
         Tessellator tessellator = Tessellator.instance;
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/designer_bg.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/designer_bg.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float scale = 32F;
         tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java b/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
similarity index 88%
rename from src/main/java/net/minecraft/client/gui/GuiSliderInteger.java
rename to src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
index c6d4ca21c..02cf45af5 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSliderInteger.java
+++ b/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
@@ -1,23 +1,23 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.ToggleableOption;
 
-public class GuiSliderInteger extends GuiButton {
+public class IntegerSliderElement extends ButtonElement {
 
 	public int sliderValue;
 	public boolean dragging;
 	private ToggleableOption<?> option;
 
-	public GuiSliderInteger(int id, int xPosition, int yPosition, ToggleableOption<?> option) {
+	public IntegerSliderElement(int id, int xPosition, int yPosition, ToggleableOption<?> option) {
 		this(id, xPosition, yPosition, 150, 20, option);
 	}
 
-	public GuiSliderInteger(int id, int xPosition, int yPosition, int width, int height, ToggleableOption<?> option) {
+	public IntegerSliderElement(int id, int xPosition, int yPosition, int width, int height, ToggleableOption<?> option) {
 		super(id, xPosition, yPosition, width, height, option.getDisplayStringValue());
 		
 		this.dragging = false;
@@ -56,7 +56,7 @@ public class GuiSliderInteger extends GuiButton {
 	public void drawButton(Minecraft mc, int mouseX, int mouseY) {
 		if (!visible) return;
 
-		FontRenderer fontrenderer = mc.fontRenderer;
+		Font font = mc.font;
 		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
@@ -105,7 +105,7 @@ public class GuiSliderInteger extends GuiButton {
 				textColor = 0xFFFFA0;
 				break;
 		}
-		drawStringCentered(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+		drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
 
 	}
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiRenderItem.java b/src/main/java/net/minecraft/client/gui/ItemElement.java
similarity index 90%
rename from src/main/java/net/minecraft/client/gui/GuiRenderItem.java
rename to src/main/java/net/minecraft/client/gui/ItemElement.java
index 9be76dd78..c613e0079 100644
--- a/src/main/java/net/minecraft/client/gui/GuiRenderItem.java
+++ b/src/main/java/net/minecraft/client/gui/ItemElement.java
@@ -18,11 +18,11 @@ import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
-public class GuiRenderItem extends Gui
+public class ItemElement extends Gui
 {
     Minecraft mc;
 
-    public GuiRenderItem(Minecraft mc)
+    public ItemElement(Minecraft mc)
     {
         this.mc = mc;
     }
@@ -60,7 +60,7 @@ public class GuiRenderItem extends Gui
             if (itemStack != null){
                 BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
                 ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-                itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f);
+                itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f);
                 if(slot instanceof GuidebookSlot){
                     if(((GuidebookSlot) slot).recipe instanceof RecipeEntryTrommel && ((GuidebookSlot) slot).item != null && ((GuidebookSlot) slot).isOutput){
                         WeightedRandomBag<WeightedRandomLootObject> loot = ((RecipeEntryTrommel)((GuidebookSlot) slot).recipe).getOutput();
@@ -75,12 +75,12 @@ public class GuiRenderItem extends Gui
                         } else {
                             s = String.valueOf(lootObject.getFixedYield());
                         }
-                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, discovered ? s : "?", 1.0f);
+                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, discovered ? s : "?", 1.0f);
                     } else {
-                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, discovered ? null : "?", 1.0f);
+                        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
                     }
                 } else {
-                    itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, discovered ? null : "?", 1.0f);
+                    itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, discovered ? null : "?", 1.0f);
                 }
             }
             GL11.glDisable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/GuiEditLabel.java b/src/main/java/net/minecraft/client/gui/LabelEditorScreen.java
similarity index 66%
rename from src/main/java/net/minecraft/client/gui/GuiEditLabel.java
rename to src/main/java/net/minecraft/client/gui/LabelEditorScreen.java
index b839adbf9..2625fce85 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditLabel.java
+++ b/src/main/java/net/minecraft/client/gui/LabelEditorScreen.java
@@ -13,7 +13,7 @@ import org.lwjgl.opengl.GL11;
 //            SignBlockEntity, ClientPacketHandler, Block, BlockEntityRenderer,
 //            ChatAllowedCharacters
 
-public class GuiEditLabel extends GuiScreen
+public class LabelEditorScreen extends Screen
 {
     private static final String allowedCharacters;
 
@@ -29,7 +29,7 @@ public class GuiEditLabel extends GuiScreen
     protected int ySize;
     protected int slot;
 
-    public GuiEditLabel(final ItemStack item, int slot)
+    public LabelEditorScreen(final ItemStack item, int slot)
     {
         screenTitle = I18n.getInstance().translateKey("gui.edit_label.label.title");
         this.item = item;
@@ -45,7 +45,7 @@ public class GuiEditLabel extends GuiScreen
     }
 
     @Override
-    protected void buttonPressed(final GuiButton button)
+    protected void buttonClicked(final ButtonElement button)
     {
         if (!button.enabled)
         {
@@ -54,7 +54,7 @@ public class GuiEditLabel extends GuiScreen
         if (button.id == 0)
         {
         	item.setCustomName(text);
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
 
             if (mc.theWorld.isClientSide)
             {
@@ -64,49 +64,49 @@ public class GuiEditLabel extends GuiScreen
     }
 
     @Override
-    public void drawScreen(final int mouseX, final int mouseY, final float f)
+    public void render(final int xm, final int ym, final float f)
     {
-        drawDefaultBackground();
+        renderBackground();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/scroll.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/scroll.png").bind();
         final int widthBG = width / 2 - 56;
         final int heightBG = 89;
         drawTexturedModalRect(widthBG, heightBG, 0, 0, 113, 34);
 
-        drawStringCentered(fontRenderer, screenTitle, width / 2, 40, 0xffffff);
+        drawStringCentered(font, screenTitle, width / 2, 40, 0xffffff);
 
-        drawStringCentered(fontRenderer, TextFormatting.get(color) + "> " + text + " <", width / 2, 100, 0xffffff);
+        drawStringCentered(font, TextFormatting.get(color) + "> " + text + " <", width / 2, 100, 0xffffff);
 
-        super.drawScreen(mouseX, mouseY, f);
+        super.render(xm, ym, f);
     }
 
     @Override
     public void init()
     {
-        controlList.clear();
+        buttons.clear();
         Keyboard.enableRepeatEvents(true);
-        controlList.add(new GuiButton(0, width / 2 - 100, height / 4 + 120, I18n.getInstance().translateKey("gui.edit_label.button.done")));
+        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120, I18n.getInstance().translateKey("gui.edit_label.button.done")));
     }
 
     @Override
-	public void keyTyped(final char c, final int i, int mouseX, int mouseY)
+	public void keyPressed(final char eventCharacter, final int eventKey, int mx, int my)
     {
-        if (i == Keyboard.KEY_BACK && text.length() > 0)
+        if (eventKey == Keyboard.KEY_BACK && text.length() > 0)
         {
             text = text.substring(0, text.length() - 1);
         }
-        if (allowedCharacters.indexOf(c) >= 0 && text.length() < 15)
+        if (allowedCharacters.indexOf(eventCharacter) >= 0 && text.length() < 15)
         {
-            text += c;
+            text += eventCharacter;
         }
-        if (i == Keyboard.KEY_RETURN || i == Keyboard.KEY_ESCAPE)
+        if (eventKey == Keyboard.KEY_RETURN || eventKey == Keyboard.KEY_ESCAPE)
         {
-            buttonPressed(controlList.get(0));
+            buttonClicked(buttons.get(0));
         }
     }
 
     @Override
-    public void onClosed()
+    public void removed()
     {
         Keyboard.enableRepeatEvents(false);
     }
diff --git a/src/main/java/net/minecraft/client/gui/ListLayout.java b/src/main/java/net/minecraft/client/gui/ListLayout.java
index c581b9475..78e4bb70c 100644
--- a/src/main/java/net/minecraft/client/gui/ListLayout.java
+++ b/src/main/java/net/minecraft/client/gui/ListLayout.java
@@ -7,7 +7,7 @@ import java.util.List;
 
 public class ListLayout{
 	
-	public final GuiScreen screen;
+	public final Screen screen;
 	
 	public final List<GuiElement> elements = new ArrayList<>();
 	
@@ -33,7 +33,7 @@ public class ListLayout{
 	private int listWidth;
 	private int listHeight;
 	
-	public ListLayout(GuiScreen screen) {
+	public ListLayout(Screen screen) {
 		this.screen = screen;
 	}
 	
diff --git a/src/main/java/net/minecraft/client/gui/MainMenuBackground.java b/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
index d193389e6..3758e1822 100644
--- a/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
+++ b/src/main/java/net/minecraft/client/gui/MainMenuBackground.java
@@ -13,6 +13,7 @@ import javax.imageio.ImageIO;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.OpenGLHelper;
@@ -21,13 +22,14 @@ import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.core.util.helper.Buffer;
+import org.slf4j.Logger;
 
 public class MainMenuBackground {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public Minecraft mc;
 	
-	private List<BackgroundListEntry> backgroundList = new ArrayList<>();
-	private Random random = new Random();
+	private final List<BackgroundListEntry> backgroundList = new ArrayList<>();
+	private final Random random = new Random();
 	
 	public MainMenuBackground(Minecraft minecraft) {
 		this.mc = minecraft;
@@ -184,7 +186,7 @@ public class MainMenuBackground {
 	}
 	
 	public boolean isEnabled() {
-		return backgroundList.size() > 0;
+		return !backgroundList.isEmpty();
 	}
 	
 	public void refresh(List<Throwable> errors) {
@@ -216,7 +218,7 @@ public class MainMenuBackground {
 					String name = backgrounds.get(i).getAsString().value;
 					
 					if(!texturePack.hasFile("/bg/" + name + ".png")) {
-						System.out.println("Skipping background '" + name + "'");
+                        LOGGER.warn("Skipping background '{}'", name);
 						continue;
 					}
 					
@@ -232,9 +234,9 @@ public class MainMenuBackground {
 	}
 	
 	public void print() {
-		System.out.println("Backgrounds: ");
+		LOGGER.info("Backgrounds: ");
 		for(BackgroundListEntry bg : backgroundList) {
-			System.out.println("    " + bg);
+            LOGGER.info("    {}", bg);
 		}
 	}
 	
@@ -244,7 +246,7 @@ public class MainMenuBackground {
 		}
 	}
 	
-	class Background {
+	static class Background {
 		
 		public int texture;
 		public int width;
@@ -268,18 +270,11 @@ public class MainMenuBackground {
 		}
 		
 		public BufferedImage loadBackgroundImage() {
-			InputStream stream = null;
-			try {
-				stream = mc.texturePackList.getResourceAsStream("/bg/" + name + ".png");
-				
-				return ImageIO.read(stream);
-			}catch (Exception e) {
-				throw new RuntimeException(e);
-			}finally {
-				try {
-					stream.close();
-				}catch (Exception e) {}
-			}
+            try (InputStream stream = mc.texturePackList.getResourceAsStream("/bg/" + name + ".png")) {
+                return ImageIO.read(stream);
+            } catch (Exception e) {
+                throw new RuntimeException(e);
+            }
 		}
 		
 		public String toString() {
